/* ricerca.c */

/* Direttive */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "abr.h"

#define ROW_LENGTH 256


/* Prototipi delle procedure secondarie */

void InterpretaLineaComando (int argc, char *argv[], char *file_dati);

/* Carica i dati contenuti in file_dati in un ABR */
ABR CaricaABR (char *file_dati);

/* Esegue sull'ABR T i comandi forniti da tastiera */
ABR EsegueComandi (ABR T);


/* Programma principale */
int main (int argc, char *argv[])
{
  /* Parte dichiarativa */
  char file_dati[ROW_LENGTH];
  ABR T;


  /* Parte esecutiva */
  InterpretaLineaComando(argc,argv,file_dati);

  /* Carica i dati contenuti in file_dati in un ABR */
  T = CaricaABR(file_dati);

  /* Esegue i comandi forniti da tastiera */
  T = EsegueComandi(T);

  /* Distrugge l'ABR */
  distruggeABR(&T);

  return EXIT_SUCCESS;
}


/* Definizione delle procedure secondarie */

void InterpretaLineaComando (int argc, char *argv[], char *file_dati)
{
  if (argc != 2)
  {
    fprintf(stderr,"Errore nella linea di comando!\n");
    fprintf(stderr,"%s [file_dati]\n",argv[0]);
    exit(EXIT_FAILURE);
  }

  strcpy(file_dati,argv[1]);
}


/* Carica i dati contenuti in file_dati in un ABR */
ABR CaricaABR (char *file_dati)
{
  FILE *fp;
  ABR T;


  /* Apre il file file_dati */
  fp = fopen(file_dati,"r");
  if (fp == NULL)
  {
    fprintf(stderr,"Errore nell'apertura del file %s!\n",file_dati);
    exit(EXIT_FAILURE);
   }

  /* Crea un ABR vuoto */

  /* Finche' ci sono numeri interi nel file */
    /* li inserisce nell'ABR */

  /* Chiude il file file_dati */
  fclose(fp);

  return T;
}


/* Esegue sull'ABR T i comandi forniti da tastiera */
ABR EsegueComandi (ABR T)
{
  /* Finche' l'utente fornisce comandi */

    /* Stampa un prompt per segnalare che si attende un comando */

    /* Legge il comando dell'utente */

    /* Identifica il comando dell'utente e l'eventuale argomento */

    /* A seconda del comando (member, insert, delete, print, empty, min, max, exit)
       esegue le operazioni appropriate */

  return T;
}
